/***********************************************************************************************************************
 *
 * blueBill Mobile - open source birdwatching
 * ==========================================
 *
 * Copyright (C) 2009, 2010 by Tidalwave s.a.s. (http://www.tidalwave.it)
 * http://bluebill.tidalwave.it/mobile/
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * $Id: Observable.java,v ae0dde520a82 2010/06/07 21:30:49 fritz $
 *
 **********************************************************************************************************************/
package it.tidalwave.bluebill.observation;

import javax.annotation.Nonnull;
import java.io.Serializable;
import org.openide.util.Lookup;
import it.tidalwave.util.As;

/*******************************************************************************
 *
 * Represents a thing observed in an {@link ObservationItem}.
 * 
 * @author  Fabrizio Giudici
 * @version $Id: Observable.java,v ae0dde520a82 2010/06/07 21:30:49 fritz $
 *
 ******************************************************************************/
public interface Observable extends Lookup.Provider, Serializable, As
  {
    public static final Class<Observable> Observable = Observable.class;

    /***************************************************************************
     *
     * Returns a {@link Finder} for {@link ObservationItem}s that include this
     * {@code Observable}.
     *
     * @return  the {@link Finder}
     *
     **************************************************************************/
    @Nonnull
    public Finder<ObservationItem> findObservationItems();
  }
